//	Copyright (c) 2008 itok ( http://itok.jp/ , http://110k.net/ )
//	All rights reserved.
//
//	Redistribution and use in source and binary forms, with or without modification, 
//	are permitted provided that the following conditions are met:
//
//	- Redistributions of source code must retain the above copyright notice, 
//	  this list of conditions and the following disclaimer.
//	- Redistributions in binary form must reproduce the above copyright notice, 
//	  this list of conditions and the following disclaimer in the documentation 
//	  and/or other materials provided with the distribution.
//	- Neither the name of itok nor the names of its contributors may be used to endorse 
//	  or promote products derived from this software without specific prior written permission.
//
//	THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS 
//	AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, 
//	INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY 
//	AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
//	IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, 
//	INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES 
//	(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
//	LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) 
//	HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, 
//	STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
//	ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, 
//	EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.


#import "PhotoZou_PhotoAdd.h"
#import "NSXMLElement-ex.h"
#import "PZPhoto.h"

@implementation PhotoZou_PhotoAdd

-(id) init
{
	if (self = [super initWithURL:[NSURL URLWithString:PHOTOZOU_REST_PATH(@"photo_add")] withMethod:@"POST"]) {
	}
	return self;
}

-(void) start
{
	if (!(_fileUrl && [_fileUrl isFileURL] && _contentType && _albumId != 0)) {
		return;
	}
//	NSLog(@"%@", _fileUrl);
//	NSMutableDictionary* params = [NSMutableDictionary dictionary];
	[m_postData setObject:[NSDictionary dictionaryWithObjectsAndKeys:
					   _fileUrl,		KEY_URL,
					   _contentType,	KEY_TYPE,
					   nil]
			   forKey:@"photo"];
	[m_postData setObject:[NSString stringWithFormat:@"%d", _albumId] forKey:@"album_id"];
	
	if (_name && [_name length] > 0) {
		[m_postData setObject:_name forKey:@"photo_title"];
	}
	if (_tags && [_tags count] > 0) {
		[m_postData setObject:[_tags componentsJoinedByString:@" "] forKey:@"tag"];
	}
	if (_comment && [_comment length] > 0) {
		[m_postData setObject:_comment forKey:@"comment"];
	}
	

	[super start];
}

-(id) responseData
{
	NSXMLDocument* xml = [super responseData];
	if (xml && [xml isKindOfClass:[NSXMLDocument class]]) {
		NSEnumerator* enume = [[[[xml rootElement] nodeForXPath:@"/rsp" error:nil] children] objectEnumerator];
		NSXMLElement* child;
		PZPhoto* photo = [[PZPhoto alloc] init];
		while (child = [enume nextObject]) {
			[photo setValue:[child objectValue] forKey:[child name]];
		}
		return [photo autorelease];
	}
	return nil;
}

@end
